package inviomail;

import java.awt.*;
import java.awt.event.*;

/**
 *
 * @author Domenico Boncoddo
 */
public class InvioMail extends Frame implements WindowListener, ActionListener {

    // Dichiarazine elementi di controllo
    Panel controllo = new Panel();
    Label txt_username = new Label("Username (es. user@libero.it):");
    TextFieldLimitato username = new TextFieldLimitato("", 0, 40);
    Label txt_password = new Label("Password:");
    TextFieldLimitato password = new TextFieldLimitato("", 0, 40);
    Label txt_destinatorio = new Label("Destinatario mail:");
    TextFieldLimitato destinatario = new TextFieldLimitato("", 0, 40);
    Label txt_oggetto = new Label("Oggetto:");
    TextFieldLimitato oggetto = new TextFieldLimitato("", 0, 40);
    // Dichiarazine elementi del corpo della mail
    TextArea messaggio = new TextArea("", 0, 0, TextArea.SCROLLBARS_VERTICAL_ONLY);
    // Dichiarazine elementi di azione
    Panel azione = new Panel();
    Button invia = new Button("Invia");
    Button cancella = new Button("Cancella");

    // Metodo costruttore che genera la finestra
    public InvioMail() {

        super("Nuovo messaggio"); // Titolo della finestra

        // Creo pannello di controllo e l'aggiungo alla finestra
        this.controllo.setLayout(new GridLayout(4, 2)); // Crea una griglia 4x2
        this.txt_username.setBackground(Color.GRAY); // Colore al Label
        this.controllo.add(this.txt_username); // Aggiunge il testo in 1 riga, 1 colonna
        this.username.addKeyListener(this.username); // Aggiunge eventi tastiera al TextFieldLimitato
        this.controllo.add(this.username); // Aggiunge TextFieldLimitato in 1 riga, 2 colonna
        this.txt_password.setBackground(Color.GRAY); // Colore al Label
        this.controllo.add(this.txt_password); // Aggiunge il testo in 2 riga, 1 colonna
        this.password.addKeyListener(this.password); // Aggiunge eventi tastiera al TextFieldLimitato
        this.password.setEchoChar('*'); // Aggiunge * per caratteri digitati in password
        this.controllo.add(this.password); // Aggiunge TextFieldLimitato in 2 riga, 2 colonna

        this.controllo.add(this.txt_destinatorio); // Aggiunge il testo in 3 riga, 1 colonna
        this.destinatario.addKeyListener(this.destinatario); // Aggiunge eventi tastiera al TextFieldLimitato
        this.controllo.add(this.destinatario); // Aggiunge TextFieldLimitato in 3 riga, 2 colonna
        this.controllo.add(this.txt_oggetto); // Aggiunge il testo in 4 riga, 1 colonna
        this.oggetto.addKeyListener(this.oggetto); // Aggiunge eventi tastiera al TextFieldLimitato
        this.controllo.add(this.oggetto); // Aggiunge TextFieldLimitato in 4 riga, 2 colonna
        super.add(this.controllo, BorderLayout.NORTH); // Inserisce pannello auth in alto

        // Creo area del messaggio e l'aggiungo alla finestra
        super.add(this.messaggio, BorderLayout.CENTER); // Inserisce corpo del messaggio al centro

        // Creo pannello di azione e l'aggiungo alla finestra
        this.azione.setLayout(new GridLayout(1, 2)); // Crea una griglia 1x2
        this.invia.addActionListener(this); // Aggiunge eventi al Bottone invia
        this.azione.add(this.invia); // Aggiunge il bottone in 1 riga, 1 colonna
        this.cancella.addActionListener(this); // Aggiunge eventi al Bottone cancella
        this.azione.add(this.cancella); // Aggiunge il bottone in 1 riga, 2 colonna
        super.add(this.azione, BorderLayout.SOUTH); // Inserisce pannello di azione in basso

        // Proprietà della finestra
        super.setResizable(false); // No al redimensionamento
        super.setSize(400, 350); // Dimensione finestra
        super.setLocation(200, 200); // Posizione
        super.addWindowListener(this); // Interazione
        super.setVisible(true); // Visibilità
    }

    // Metodo principale che esegue l'istanza
    public static void main(String[] args) {
        new InvioMail();
    }

    // Metodo per la gestione degli eventi dei bottoni
    @Override
    public void actionPerformed(ActionEvent e) {

        String comando = e.getActionCommand(); // Preleva il comando

        // Cancella la TextArea
        if (comando.equals("Cancella")) {

            // Imposta i campi in base a cosa c'è scritto dentro
            this.destinatario.setText(this.destinatario.getText());
            this.oggetto.setText(this.oggetto.getText());
            this.messaggio.setText(this.messaggio.getText());

            // Reimposta i campi
            this.destinatario.setText("");
            this.oggetto.setText("");
            this.messaggio.setText("");
        }

        // Invia il messaggio
        if (comando.equals("Invia")) {
            // Imposta i campi in base a cosa c'è scritto dentro
            this.username.setText(this.username.getText());
            this.password.setText(this.password.getText());
            this.destinatario.setText(this.destinatario.getText());
            this.oggetto.setText(this.oggetto.getText());
            this.messaggio.setText(this.messaggio.getText());

            // Invia il messaggio
            TCPClient.inviaMessaggio(this.username.getText(), this.password.getText(), this.destinatario.getText(), this.oggetto.getText(), this.messaggio.getText());

            // Reimposta i campi
            this.destinatario.setText("");
            this.oggetto.setText("");
            this.messaggio.setText("");
        }

    }

    // Metodo per attivare il pulsante di chiusura della finestra
    @Override
    public void windowClosing(WindowEvent e) {
        System.exit(0);
    }

    @Override
    public void windowOpened(WindowEvent e) {
    }

    @Override
    public void windowClosed(WindowEvent e) {
    }

    @Override
    public void windowIconified(WindowEvent e) {
    }

    @Override
    public void windowDeiconified(WindowEvent e) {
    }

    @Override
    public void windowActivated(WindowEvent e) {
    }

    @Override
    public void windowDeactivated(WindowEvent e) {
    }
}
