package inviomail;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.Socket;
import java.net.UnknownHostException;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Domenico Boncoddo
 */
public class TCPClient {

    public static void inviaMessaggio(String username, String password, String destinatario, String oggetto, String messaggio) {

        // Sequenza dei comandi da inviare
        String comandi[] = new String[15];
        comandi[0] = "EHLO client";
        comandi[1] = "AUTH LOGIN";
        comandi[2] = Convertitore.inBase64(username);
        comandi[3] = Convertitore.inBase64(password);
        comandi[4] = "MAIL FROM: <" + username + ">";
        comandi[5] = "RCPT to: <" + destinatario + ">";
        comandi[6] = "DATA";
        comandi[7] = "From: " + username;
        comandi[8] = "To: " + destinatario;
        comandi[9] = "Subject: " + oggetto;
        comandi[10] = "";
        comandi[11] = messaggio;
        comandi[12] = ".";
        comandi[13] = "QUIT";

        String risposta = null; // Stringa di caratteri

        try {
            Socket clientSocket = new Socket("smtp.libero.it", 25); // Connessione al server SMTP di libero con handshake
            DataOutputStream scritturaServer = new DataOutputStream(clientSocket.getOutputStream()); // Buffer di scrittura sul server
            BufferedReader letturaServer = new BufferedReader(new InputStreamReader(clientSocket.getInputStream())); // Buffer di lettura dal server

            scritturaServer.writeBytes(comandi[0] + '\n'); // Scrive sul server comando di riconoscimento

            // Legge risposte di presentazione del server
            for (int i = 0; i < 8; i++) {
                risposta = letturaServer.readLine(); // Legge dal server
                System.out.println("Risposta del server: " + risposta); // Visualizzazione dei dati ricevuti dal server
            }

            // Scrive e legge dal server per la specifica del mittente e del destinatario
            for (int i = 1; i < 7; i++) {
                scritturaServer.writeBytes(comandi[i] + '\n'); // Scrive sul server
                risposta = letturaServer.readLine(); // Legge dal server
                System.out.println("Risposta del server: " + risposta); // Visualizzazione dei dati ricevuti dal server
            }

            // Invia il messaggio
            for (int i = 7; i < 13; i++) {
                scritturaServer.writeBytes(comandi[i] + '\n'); // Scrive sul server
            }

            // Legge il responso dal server
            risposta = letturaServer.readLine(); // Legge dal server
            System.out.println("Risposta del server: " + risposta); // Visualizzazione dei dati ricevuti dal server

            // Chiude la connessione
            scritturaServer.writeBytes(comandi[13] + '\n');
            risposta = letturaServer.readLine(); // Legge dal server
            System.out.println("Risposta del server: " + risposta); // Visualizzazione dei dati ricevuti dal server

            clientSocket.close(); // Chiude il socket di connessione
        } catch (UnknownHostException ex) {
            Logger.getLogger(TCPClient.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(TCPClient.class.getName()).log(Level.SEVERE, null, ex);
        }

    }
}
